{
Copyright 2011 Kapustin Andrey

This file is part of FileRouter.

FileRouter is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FileRouter is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FileRouter.  If not, see <http://www.gnu.org/licenses/>.

Код распространяется по лицензии GPL 3
Автор: Капустин Андрей, 2011 г.
}
program frouter;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, CustApp,{IniFiles,}Windows,StrUtils,{lNet, lSMTP, lMimeWrapper,}Dialogs,{ShellApi,}
  sendmail,
  //smtpsend,mimemess,mimepart,synachar,ssl_openssl, //synapse
  Process, unitfunc;

const ver='0.3'; // Версия программы

type
TFileMon = class(TCustomApplication)
  protected
    procedure DoRun; override;
  public
    constructor Create(TheOwner: TComponent); override;
    destructor Destroy; override;
    procedure WriteHelp; virtual;
//    function ReadSet:boolean;
//    procedure WriteLnUtf(str:string);
//    Function WinToDos(Const S: String) : String;
//    Function DosToWin(Const S: String) : String;
    procedure WriteLog (Msg:string;utf:boolean);
//    procedure WriteLog (Msg:string);
    function GetLogName:String;
    procedure LoadRules(FileName:string);
    procedure RunRules (RuleName:string);
    procedure RunRule(Num:integer);
    function CopyF(sour,dest:string):boolean;
    function GetValue (Str,Key:string):string;
    function FindStrVar (S:string):string;
    function ReplDate(S:string):string;
    //procedure DoFile(Num:integer; FileName:string);
    procedure DoFiles(Num:integer; Files:TStringList);
    function CreateDir(dest:string):boolean;
    function FindStrInFile(str:string;FileName:string):boolean;
//    function ExecAndWait(const FileName, Param: String; const WinState: Word): boolean;
    function Exec(const FileName, Param: String; Wait:boolean): boolean;  // Платформонезавис
    function LookForPreviousInstance:boolean;
    function ReplaceFileName(Str:string;Files:TStringList):string;
//    procedure ExecNoWait(const FileName, Param: ShortString; const WinState: Word);
//    function ExecNoWait(const FileName, Param: ShortString; const WinState: Word):boolean;
    function UnRAR(RarFile:string;destDir:string):boolean;
    function ReplPath(Str:string;FullPath:string):string;
    //-----------------
 //   SendMail:TSendMail;
    SendMail:TSendMailS;
    config:string; // Имя файла с настройками программы
    LogName:String; // Имя лог файла
//    mailfrom:string; // От имени кого отправляется почта
//    mailsrv:string; // Имя почтового сервера
//    mailport:integer;
    RulesTxt:TStringList; // Правила кучей строк
    CurrentRule:string; // Обрабатываемое правило
    FoundAtom : TAtom;  // Уникальный идентификатор программы
  end;

{
// класс для отправки почты
type
  TSendMail = class
   private
    FSMTP: TLSMTPClient; // this is THE smtp connection
//    FSSL: TLSSLSession;
    FConn: Boolean; // Соединено с сервером
    FErr:Boolean; // Ошибка при соединении

//    function GetAnswer(const s: string; const MaskInput: Boolean = False): string;
    { these events are used to see what happens on the SMTP connection. They are used via "CallAction".
      OnReceive will get fired whenever new data is received from the SMTP server.
      OnConnect will get fired when connecting to server ended with success.
      OnDisconnect will get fired when the other side closed connection gracefully.
      OnError will get called when any kind of net error occurs on the connection. }
    procedure OnReceive(aSocket: TLSocket);
    procedure OnConnect(aSocket: TLSocket);
    procedure OnDisconnect(aSocket: TLSocket);
    procedure OnError(const msg: string; aSocket: TLSocket);
    { This event is used to monitor TLS handshake. If SSL or TLS is used
      we will know if the handshake went ok if this event is fired on the seesion }
//    procedure OnSSLConnect(aSocket: TLSocket);
   public
    constructor Create;
    function Send(srv:string; port:word; mailfrom,mailto,subj,data,att:string):boolean; // Отправить почту
    FQuit: Boolean;  // helper for main loop

  end;

 }









{TSendMail}
   {
procedure TSendMail.OnReceive(aSocket: TLSocket);
var
  s: string;
begin
  if FSMTP.GetMessage(s) > 0 then // if we actually received something from SMTP server, write it for the user
    Write(s);
end;

procedure TSendMail.OnConnect(aSocket: TLSocket);
begin
  Writeln('Connected'); // inform user of successful connect
  FConn:=true;
end;

procedure TSendMail.OnDisconnect(aSocket: TLSocket);
begin
  Writeln('Lost connection'); // inform user about lost connection
  FQuit := True; // since SMTP shouldn't do this unless we issued a QUIT, consider it to be end of session and quit program
  FConn:=false;
end;

procedure TSendMail.OnError(const msg: string; aSocket: TLSocket);
begin
  Writeln(msg); // inform about error
  FErr:=true;
  FQuit := True;
end;
{
procedure TSendMail.OnSSLConnect(aSocket: TLSocket);
begin
  Writeln('SSL handshake was successful');
end;
 }
constructor TSendMail.Create;
begin
  inherited;

  FQuit := False;
  FConn:=false;
  FErr:=false;
  FSMTP := TLSMTPClient.Create(nil);
//  FSMTP.Timeout := 100; // responsive enough, but won't hog CPU
  FSMTP.OnReceive := @OnReceive; // assign all events
  FSMTP.OnConnect := @OnConnect;
  FSMTP.OnDisconnect := @OnDisconnect;
  FSMTP.OnError := @OnError;
end;

{Отправка сообщения}
function TSendMail.Send(srv:string; port:word; mailfrom,mailto,subj,data,att:string):boolean;
var
//  s, Addr, Subject, Sender, Recipients, Message: string;
//  c: Char;
//  i,k:integer;
  FMimeStream: TMimeStream;
  Subject: string;
 // port:word;
begin
//  port:=25;
  Result:=false;
  FMimeStream:=TMimeStream.Create;
  FMimeStream.AddTextSection('');
  if FileExists(att) then FMimeStream.AddFileSection(att);
//  Write('Connecting to ', Addr, ':', Port, '... ');
   if FSMTP.Connect(srv, Port) then
    begin
    repeat  // try to connect
    WriteLn('Wait connecting...');
//    WriteLog('Ждем подключения...',true);
    FSMTP.CallAction;  // if inital connect went ok, wait for "acknowlidgment" or otherwise
    until  Fconn or FErr; // ЖДем или обшику или подключение
    end;
    if FErr then exit; // ошибка подключения к серверу
   FSMTP.CallAction;
    FSMTP.Ehlo;
    FSMTP.CallAction;
      Subject := Ansitoutf8(Subj);
       FMimeStream.Reset; // make sure we can read it again
       TMimeTextSection(FMimeStream[0]).Text := Ansitoutf8(Data); // change to text
       FSMTP.SendMail(mailfrom, mailto, Subject, FMimeStream); // send the mail given user data
//       WriteLog('Отправили письмо...',true);
       FSMTP.CallAction;
       FSMTP.Quit;
       FSMTP.CallAction;
    while FConn do
    begin
    //  FSMTP.Quit;
//      WriteLog('Ждем отключения...',true);
      FSMTP.CallAction;
    end;
//   WriteLog('Отключились...',true);
   FMimeStream.Destroy;
   Result:=true;//Ferr;//true;
 //  ReadLn;
end;
  }

//=====================================================================


{TFRouter}

//-----------------------------------------------------------------------
{Получение значения по ключу из строки типа -key1=value1; -key2=value2; ...}
function TFileMon.GetValue (Str,Key:string):string;
var
 i,j,k,len:integer;
 S:string;
begin
Result:='';
j:=Pos('#',Str); // Если содержит символ комментария
if j<>0 then Str:=LeftStr(Str,j-1); // Убираем символы после комментария
if str='' then exit;

len:=Length(str);
i:=1;
// Ищем строку между ; и =
// Первый ключ сразу до =
while (i<len) and (i<>0) do
  begin
      j:=PosEx('=',Str,i);
      if j<>0 then
        begin
           S:=MidStr(Str,i,j-i); // Подстрока между ; и =
           S:=Trim(S);
                 if SameText(S,Key) then // Ключ совпал с переданным
                      begin
                          k:=PosEx(';',Str,j+1);
                          if k<>0 then
                              begin
                              S:=MidStr(Str,j+1,k-j-1);
                              Result:=Trim(s);
                              exit;
                              end;
                      end;
        end
       else
        begin
          break;
       end;
    i:=PosEx(';',Str,j+1);
    if i>0 then inc(i);
  end;
end;
//-----------------------------------------------------------------------
{Поиск в строке первой подстроки типа %yyyy% и возвращение ее содержимого без %%}
function TFileMon.FindStrVar (S:string):string;
var
 i,j:integer;
begin
Result:='';
if s='' then exit;
i:=Pos('%',S); // Первый символ %
if i=0 then exit;
j:=PosEx('%',S,i+1); // Второй символ %
if j=0 then exit;
Result:=MidStr(S,i+1,j-i-1); // Строка между %
end;
//-----------------------------------------------------------------------
{Выполнение загруженных правил
RuleName - имя правил для исполнения (Outpost, inpost)
}
procedure TFileMon.RunRules (RuleName:string);
var
 str:string;
 i:integer;
begin
// Перебор всех строк
for i:=0 to RulesTXT.Count-1 do
 begin
   str:=GetValue(RulesTXT[i],'Rule');
   if SameText(str,RuleName) or SameText(str,'settings') then
     begin
//        writeLog('Run rule '+RulesTXT[i],false);
      RunRule(i);
  //     WriteLog(' '+RulesTXT[i]+' Содержит правило Test',true);
     end;

 end;
end;
//------------------------------------------------------------------------
{
 Выполнение правила с номером строки Num в RulesTXT
}
procedure TFileMon.RunRule(Num:integer);
var
  sr: TSearchRec;
  FileAttrs: Integer;
  source,s,act,rule:string;
  contain:string;
  msg:string;

  suc:boolean;
  Files:TStringList; // список файлов
begin
 Files:=TStringList.Create;
 FileAttrs := faAnyFile+faArchive;
 source:=GetValue(RulesTXT[num],'s');
 source:=ReplDate(source);

 act:=GetValue(RulesTXT[num],'act');
 rule:=GetValue(RulesTXT[num],'rule');
 if SameText(rule,'settings') then // Строка с настройками
   begin
    //mailsrv:=GetValue(RulesTXT[num],'mailsrv');
    SendMail.mailsrv:=GetValue(RulesTXT[num],'mailsrv');
    //mailfrom:=GetValue(RulesTXT[num],'mailfrom');
    SendMail.mailfrom:=GetValue(RulesTXT[num],'mailfrom');
    try
    SendMail.mailport:=StrToInt(GetValue(RulesTXT[num],'mailport'));
    except
         WriteLog('[Ошибка] чтения smtp порта в настройках',true);
    end;
   // WriteLog('Прочитаны настройки '+mailsrv+' '+mailfrom,true);
    exit;
   end;
 if SameText(act,'run') then
   begin
   msg:=Utf8ToAnsi('Запуск ')+source;
   WriteLog(msg,false);
   //s:=ExtractFilePath(source);
   // if s='' then source:=ExtractFilePath(ExeName)+source;
   suc:=Exec(WinToDos(source), '',true);
      if suc then
           begin
            msg:=Utf8ToAnsi('Выполнена команда ')+source;
            WriteLog(msg,false);
           end
         else
           begin
           msg:=Utf8ToAnsi('[Ошибка] Не удалось выполнить ')+source;
           WriteLog(msg,false);
           end;

   exit;
   end;

 contain:=GetValue(RulesTXT[num],'contain');
 s:=ExtractFilePath(source);
 s:=WinToDos(s);
 if Not SysUtils.DirectoryExists(s) then
   begin
    msg:=Utf8ToAnsi('[Ошибка] Каталог источника не найден ')+s;
     WriteLog(msg,false);
 //   writeLog('[Error] Source dir not exists '+s,false);
    exit;
   end;
// writeLog('Start searching in dir '+source,false);
 if SysUtils.FindFirst(WinToDos(source), FileAttrs, sr) = 0 then
    begin
      repeat
        if (sr.Attr and faDirectory) <> faDirectory then // Это файл
        begin
   //          writeLog('Начало обработки файла '+sr.name,true);
            suc:=FindStrInFile(contain,s+sr.Name);
             if suc then Files.Add(s+sr.Name);
              //DoFile(num,s+sr.Name);
//             ReadLn;
        end;
      until SysUtils.FindNext(sr) <> 0;
     SysUtils.FindClose(sr);
    end;
if Files.Count>0 then DoFiles(num,Files); // Обработать файлы скопом
Files.Free;
end;
//------------------------------------------------------------------------
{Произвести над файлами Files действие из строки Num в RulesTXT }
procedure TFileMon.DoFiles(Num:integer; Files:TStringList);
var
 act:string;
 dest:string;
 suc,suc2:boolean;
 mailto,subj:string;
 msg,dest2,filename:string;
 msgsend:string;
 MsgErr:string;
 cmd,param:string;
 i:integer;
begin
act:=GetValue(RulesTXT[num],'act');
//if Not FileExists(FileName) then exit;
if SameText(act,'copy') then
  begin
     dest:=GetValue(RulesTXT[num],'d');
     dest:=ReplDate(dest);
     dest:=WinToDos(dest);
     if not CreateDir(dest) then exit;
     for i:=0 to Files.Count-1 do
      begin
       if Not FileExists(Files[i]) then continue;
       dest2:=dest+'\'+ExtractFileName(Files[i]);
       suc:=CopyF (Files.Strings[i],dest2);
         if suc then
           begin
            msg:=Utf8ToAnsi('Файл скопирован ')+DosToWin(Files[i])+Utf8ToAnsi(' в ')+DosToWin(dest);
            WriteLog(msg,false);
           end
         else
           begin
           msg:=Utf8ToAnsi('[Ошибка] Не удалось скопировать файл ')+DosToWin(Files[i])+Utf8ToAnsi(' в ')+DosToWin(dest);
           WriteLog(msg,false);
           end;
      end;
  end;
if SameText(act,'move') then
  begin
     dest:=GetValue(RulesTXT[num],'d');
     dest:=ReplDate(dest);
     dest:=WinToDos(dest);
     if not CreateDir(dest) then exit;
     for i:=0 to Files.Count-1 do
     begin
     if Not FileExists(Files[i]) then continue;
     dest2:=dest+'\'+ExtractFileName(Files[i]);
     suc:=CopyF (Files[i],dest2);
     if suc then
        begin
        suc2:=DeleteFile(PChar(Files[i]));
               if suc2 then
                  begin
                   msg:=Utf8ToAnsi('Файл перемещен ')+DosToWin(Files[i])+Utf8ToAnsi(' в ')+DosToWin(dest);
                   WriteLog(msg,false);
                  end
                 else
                   begin
                   msg:=Utf8ToAnsi('[Ошибка] Не удалось удалить файл ')+DosToWin(Files[i]);
                   WriteLog(msg,false);
                   end;
        end
      else
        begin
          msg:=Utf8ToAnsi('[Ошибка] Не удалось переместить файл ')+DosToWin(Files[i])+Utf8ToAnsi(' в ')+DosToWin(dest);
          WriteLog(msg,false);
        end;
     end;
  end;
if SameText(act,'send') then   // отправка файла
  begin
    mailto:=GetValue(RulesTXT[num],'to');
    subj:=GetValue(RulesTXT[num],'subj');
    msgsend:=GetValue(RulesTXT[num],'text');
   for i:=0 to Files.Count-1 do
   begin
    filename:=Files[i];
   // filename:=WinToDos(FileName);
    suc:=SendMail.Send (mailto,subj,msgsend,filename,MsgErr);
     if suc then
         begin
          msg:=Utf8ToAnsi('Файл отправлен ')+DosToWin(FileName)+Utf8ToAnsi(' на ')+mailto+Utf8ToAnsi(' тема: ')+subj;
          WriteLog(msg,false);
         end
       else
         begin
          msg:=Utf8ToAnsi('[Ошибка] Файл неудалось отправить ')+DosToWin(FileName)+Utf8ToAnsi(' на ')+mailto+FileName+Utf8ToAnsi(MsgErr);//Utf8ToAnsi(' тема: ')+subj;
          WriteLog(msg,false);
         end;
    end;
  end;
//---------
if SameText(act,'UnRAR') then // Распаковка RAR
  begin
     dest:=GetValue(RulesTXT[num],'d');
     dest:=WinToDos(dest);
//     dest:=ReplDate(dest);
//     dest2:= ReplPath(dest,Files[i]);

//     if not CreateDir(dest2) then exit;
//     dest2:=dest2+'\';
     for i:=0 to Files.Count-1 do
      begin
       if Not FileExists(Files[i]) then continue;
       dest2:= ReplPath(dest,Files[i]);
       dest2:=ReplDate(dest2);
       CreateDir(dest2);
       dest2:=dest2+'\';
       suc:=UnRar (Files.Strings[i],dest2);

         if suc then
           begin
            msg:=Utf8ToAnsi('Файл RAR распакован ')+DosToWin(Files[i])+Utf8ToAnsi(' в ')+DosToWin(dest2);
            WriteLog(msg,false);
           end
         else
           begin
           msg:=Utf8ToAnsi('[Ошибка] Не удалось распаковать RAR файл ')+DosToWin(Files[i])+Utf8ToAnsi(' в ')+DosToWin(dest2);
           WriteLog(msg,false);
           end;
      end;
  end;


if SameText(act,'sendmsg') then  // отравка уведомления, без отправки файла
  begin
    mailto:=GetValue(RulesTXT[num],'to');
    subj:=GetValue(RulesTXT[num],'subj');
    msgsend:=GetValue(RulesTXT[num],'text');
//    dest:='';
//    dest2:='';
//    for i:=0 to Files.Count-1 do
//    begin
//      if i>0 then
//        begin
//        dest:=dest+', ';
//        dest2:=dest2+', ';
//        end;
//      dest:=dest+ExtractFileName(Files[i]);
//      dest2:=dest2+Files[i];
//    end;
//    msgsend:=StringReplace(msgsend,'%filename%',dest,[rfReplaceAll, rfIgnoreCase]);
//    msgsend:=StringReplace(msgsend,'%file%',dest2,[rfReplaceAll, rfIgnoreCase]);
msgsend:=ReplaceFileName(msgsend,Files);
    suc:=SendMail.Send(mailto,subj,msgsend,'',MsgErr);
     if suc then
         begin
          msg:=Utf8ToAnsi('Сообщение о файле(ах) отправлено ')+dest+Utf8ToAnsi(' на ')+mailto+Utf8ToAnsi(' тема: ')+subj;
          WriteLog(msg,false);
         end
       else
         begin
          msg:=Utf8ToAnsi('[Ошибка] Сообщение о файле(ах) неудалось отправить ')+dest+Utf8ToAnsi(' на ')+mailto+FileName+Utf8ToAnsi(MsgErr);//Utf8ToAnsi(' тема: ')+subj;
          WriteLog(msg,false);
         end;
  end;
 if SameText(act,'RunWait') then  // запуск с ожиданием
  begin
    cmd:=GetValue(RulesTXT[num],'cmd');
    param:=GetValue(RulesTXT[num],'param');
    cmd:=ReplaceFileName(cmd,Files); // Замена имен файлов
    param:=ReplaceFileName(param,Files);
    cmd:=ReplDate(cmd);   // Замена дат
    param:=ReplDate(param);


   msg:=Utf8ToAnsi('Запуск ')+cmd+' '+param;
   WriteLog(msg,false);
   //s:=ExtractFilePath(source);
   // if s='' then source:=ExtractFilePath(ExeName)+source;
   suc:=Exec(WinToDos(cmd), param,true);
      if suc then
           begin
            msg:=Utf8ToAnsi('Выполнена команда ')+cmd+' '+param;
            WriteLog(msg,false);
           end
         else
           begin
           msg:=Utf8ToAnsi('[Ошибка] Не удалось выполнить ')+cmd+' '+param;
           WriteLog(msg,false);
           end;
  end;
  if SameText(act,'RunNoWait') then  // запуск без ожидания
  begin
    cmd:=GetValue(RulesTXT[num],'cmd');
    param:=GetValue(RulesTXT[num],'param');
    cmd:=ReplaceFileName(cmd,Files); // Замена имен файлов
    param:=ReplaceFileName(param,Files);
    cmd:=ReplDate(cmd);   // Замена дат
    param:=ReplDate(param);

//    param:=Utf8ToAnsi(param);
//    cmd:=Utf8ToAnsi(cmd);

//   msg:=Utf8ToAnsi('Запущена команда ')+cmd+' '+param;
  // WriteLog(msg,false);
   //s:=ExtractFilePath(source);
   // if s='' then source:=ExtractFilePath(ExeName)+source;
   //ExecNoWait(cmd, param,SW_SHOWNormal);
   suc:=Exec(WinToDos(cmd), param,false);
      if suc then
           begin
            msg:=Utf8ToAnsi('Запущена команда ')+cmd+' '+param;
            WriteLog(msg,false);
           end
         else
           begin
           msg:=Utf8ToAnsi('[Ошибка] Не удалось запустить ')+cmd+' '+param;
           WriteLog(msg,false);
           end;
  end;


end;
//-------------------------------------------------------------------------
// Распаковка рар файла
function TFileMon.UnRAR(RarFile:string;destDir:string):boolean;
var
 cmd,param:string;
 //hinst:HINSTANCE;
begin
  cmd:=ExtractFileDir(ExeName);
  cmd:=WinToDos(cmd);
  cmd:=cmd+'\rar.exe';
  //cmd:='rar.exe';
  param:=' e -y "'+RarFile+'" "'+destDir+'"';
  //param:=Utf8ToAnsi(param);
  //hinst:=ShellExecute(0, 'open',PChar(cmd), PChar(param), nil, SW_SHOWNORMAL) ;
  //WaitForSingleObject(hinst, INFINITE);
  //result:=true;
  result:=Exec(cmd, param,true);
end;
//-------------------------------------------------------------------------
{
 Замена в строке на всякие имена файла
 %File% - имя файла без расширения
// Остальное в проекте
 %FileName% - Имя файла с расширением
 %FullPath% - Полный путь к файлу
 %Path% - Каталог без имени файла
 %Ext% - расширение

}
function TFileMon.ReplPath(Str:string;FullPath:string):string;
var
 filestr:string;
 itogstr:string;
 i:integer;
begin
 // Имя файла без расширения
 filestr:=ExtractFileName(FullPath);
 i:=Pos('.',filestr);
 if (i>2) then
   begin
    filestr:= LeftStr(filestr,i-1)
   end;
  itogstr:=StringReplace(Str,'%File%',filestr,[rfReplaceAll, rfIgnoreCase]);

  Result:=itogstr;
end;

//-------------------------------------------------------------------------
// Замена в строке Str строк %file% (список длинных имен файлов) %filename% (список коротких имен файлов) %count% (кол-во файлов)
function TFileMon.ReplaceFileName(Str:string;Files:TStringList):string;
var
dest,dest2:string;
itog:string;
i:integer;
begin
dest:='';
    dest2:='';
    for i:=0 to Files.Count-1 do
    begin
      if i>0 then
        begin
        dest:=dest+', ';
        dest2:=dest2+', ';
        end;
      dest:=dest+ExtractFileName(Files[i]);
      dest2:=dest2+Files[i];
    end;
    itog:=StringReplace(Str,'%filename%',dest,[rfReplaceAll, rfIgnoreCase]);
    itog:=StringReplace(itog,'%file%',dest2,[rfReplaceAll, rfIgnoreCase]);
    itog:=StringReplace(itog,'%count%',IntToStr(Files.Count),[rfReplaceAll, rfIgnoreCase]);
Result:=itog;
end;

//-------------------------------------------------------------------------
function TFileMon.LookForPreviousInstance:boolean;
var
  PreviousInstanceWindow : hWnd;
  AppName : array[0..30] of char;

  AtomText:string;
begin
  // помещаем имя приложения в AtomText
  Result:=false;
  AtomText:='OO '+ExeName;
  if ParamCount>0 then AtomText:=AtomText+' '+CurrentRule;//ParamStr(1);
  //StrFmt(AtomText, 'OnlyOne%s', [Copy(Application.Title,1,20)]);
  // Проверяем, не создано ли уже атома с таким именем приложения
  FoundAtom := GlobalFindAtom(PChar(AtomText));
  if FoundAtom <> 0 then { эта копия приложения уже запущена }
  begin
    writeLog('Программа уже выполняется',true);
    Result:=true;
    //Terminate;
    exit;
{    StrFmt(AppName,'%s', [Application.Title]);
    // изменяем текущий заголовок, чтобы FindWindow не видела его
    Application.ShowMainForm := false;
    Application.Title := 'destroy me';
    // ищем предыдущую копию приложения
    PreviousInstanceWindow := FindWindow(nil,AppName);
    // Передаём фокус на предыдущую копию приложения
    // завершаем текущую копию
    Application.Terminate;

    if PreviousInstanceWindow <> 0 then
      if IsIconic(PreviousInstanceWindow) then
        ShowWindow(PreviousInstanceWindow,SW_RESTORE)
      else
        SetForegroundWindow(PreviousInstanceWindow);}
  end;
  // создаём глобальный атом, чтобы предотвратить
  // запуск другой копии приложения
  FoundAtom := GlobalAddAtom(PChar(AtomText));
end;
//-------------------------------------------------------------------------
// Запуск без ожидания Win
{
function TFileMon.ExecNoWait(const FileName, Param: ShortString; const WinState: Word):boolean;
var
  StartInfo: TStartupInfo;
  ProcInfo: TProcessInformation;
  CmdLine: ShortString;
begin
  { Помещаем имя файла между кавычками, с соблюдением всех пробелов в именах Win9x }
  CmdLine := '"' + Filename + '" ' + Param;
  FillChar(StartInfo, SizeOf(StartInfo), #0);
  with StartInfo do
  begin
    cb := SizeOf(StartInfo);
    dwFlags := STARTF_USESHOWWINDOW;
    wShowWindow := WinState;
  end;
  Result := CreateProcess(nil, PChar( String( CmdLine ) ), nil, nil, false,
                          CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS, nil,
                          PChar(ExtractFilePath(Filename)),StartInfo,ProcInfo);

end;
}
{
function TFileMon.ExecNoWait(const FileName, Param: ShortString; const WinState: Word):boolean;
var
  CmdLine: ShortString;
begin
  CmdLine := '"' + Filename + '" ' + Param;
  ShellExecute(null,'open',PChar( String( CmdLine ) ),nil,nil,WinState);//SW_SHOWNORMAL)
end;
 }

//-------------------------------------------------------------------------
// Запуск вшнешней проги
function TFileMon.Exec(const FileName, Param: String; Wait:boolean): boolean;
var
  AProcess: TProcess;
  //   AStringList: TStringList;
  CmdLine:  string;
  str:string;
begin
try
  { Помещаем имя файла между кавычками, с соблюдением всех пробелов в именах Win9x }
  Result:=false;
  CmdLine := '"' + Filename + '" ' + Param;

  AProcess := TProcess.Create(nil);
  //AStringList := TStringList.Create;

  AProcess.CommandLine := CmdLine;
     //AProcess.Options := AProcess.Options + [poUsePipes,poNewConsole,poStderrToOutPut];  // Это для чтения StdOut процесса
     AProcess.Options := AProcess.Options + [poNewConsole,poStderrToOutPut];  // Это для чтения StdOut процесса
     AProcess.ShowWindow:=swoShowNormal;
  if Wait then
    AProcess.Options := AProcess.Options + [poWaitOnExit];


  // Now that AProcess knows what the commandline is
  // we will run it.
  AProcess.Execute;
  if Wait then // Получаем код возврата
  begin
    //if AProcess.ExitStatus=0 then Result:=true;
    Result:=true;
  end
  else
  begin
    Result := true; // Без ожидания, типа успешно запустились
  end;


 // if Wait then // Читаем StdOut
 //    LastStdOut.LoadFromStream(AProcess.Output);

  //   AStringList.Free;
  AProcess.Free;

except
    On E: Exception do
    begin
      Result:=false;
    end;
end;
end;

//-------------------------------------------------------------------------
{Запуск с ожиданием Win
Параметр FileName = Имя внешней программы.
Параметр Params = Параметры, необходимые для запуска внешней программы
Параметр WinState = Указывает - как будет показано окно:
Для этого параметра мы можем так же использовать следующие константы:
SW_HIDE, SW_MAXIMIZE, SW_MINIMIZE, SW_SHOWNORMAL

}
{
function TFileMon.ExecAndWait(const FileName, Param: String; const WinState: Word): boolean;
var
  StartInfo: TStartupInfo;
  ProcInfo: TProcessInformation;
  CmdLine: String;
begin
  { Помещаем имя файла между кавычками, с соблюдением всех пробелов в именах Win9x }
  CmdLine := '"' + Filename + '" ' + Param;
  FillChar(StartInfo, SizeOf(StartInfo), #0);
  with StartInfo do
  begin
    cb := SizeOf(StartInfo);
    dwFlags := STARTF_USESHOWWINDOW;
    wShowWindow := WinState;
  end;
  Result := CreateProcess(nil, PChar(  CmdLine ), nil, nil, false,
///Result := CreateProcess(PChar(CmdLine), nil , nil, nil, false,
                          CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS, nil,
                          PChar(ExtractFilePath(Filename)),StartInfo,ProcInfo);
  { Ожидаем завершения приложения }
  if Result then
  begin
    WaitForSingleObject(ProcInfo.hProcess, INFINITE);
    { Free the Handles }
    CloseHandle(ProcInfo.hProcess);
    CloseHandle(ProcInfo.hThread);
  end;
end;

 }

//-------------------------------------------------------------------------
{создание каталога если не существует и запись в лог}
function TFileMon.CreateDir(dest:string):boolean;
var
 suc:boolean;
 msg:string;
begin
   //  dest:=WinToDos(dest);
     if not DirectoryExists(dest) then
       begin
        suc:=ForceDirectories(dest);
        if suc then
            begin
           msg:=Utf8ToAnsi('Каталог создан ')+DosToWin(dest);
            WriteLog(msg,false);
            Result:=true;
            end
         else
             begin
            msg:=Utf8ToAnsi('[Ошибка] Каталог неудалось создать ')+DosToWin(dest);
            WriteLog(msg,false);
             Result:=false;
             end;
       end
      else
       begin
         Result:=true;
       end;
end;
//------------------------------------------------------------------------
{Произвести над файлом FileName действие из строки Num в RulesTXT }
{
procedure TFileMon.DoFile(Num:integer; FileName:string);
var
 act:string;
 dest:string;
 suc,suc2:boolean;
 mailto,subj:string;
 msg:string;
begin
if Not FileExists(FileName) then exit;
act:=GetValue(RulesTXT[num],'act');
if SameText(act,'copy') then
  begin
     dest:=GetValue(RulesTXT[num],'d');
     dest:=ReplDate(dest);
//     WriteLog ('dest='+dest,false);
     if not DirectoryExists(dest) then
       begin
        suc:=ForceDirectories(dest);
        if suc then
            begin
            msg:=Utf8ToAnsi('Каталог создан ')+dest;
            WriteLog(msg,false);
           // WriteLog ('Dir created '+dest,false);
            end
         else
             begin
            msg:=Utf8ToAnsi('[Ошибка] Каталог неудалось создать ')+dest;
            WriteLog(msg,false);
//             WriteLog ('[Error] Not dir created '+dest,false);
             exit;
             end;
       end;
     dest:=dest+'\'+ExtractFileName(FileName);
     suc:=CopyF (FileName,dest);
     if suc then
         begin
          msg:=Utf8ToAnsi('Файл скопирован ')+FileName+Utf8ToAnsi(' в ')+dest;
          WriteLog(msg,false);
//         WriteLog ('File '+FileName+' copied to '+dest,false)
         end
       else
         begin
          msg:=Utf8ToAnsi('[Ошибка] Не удалось скопировать файл ')+FileName+Utf8ToAnsi(' в ')+dest;
          WriteLog(msg,false);
//         WriteLog ('[Error] Not copied file '+FileName+' to '+dest,false);
         end;
  end;
if SameText(act,'move') then
  begin
     dest:=GetValue(RulesTXT[num],'d');
     dest:=ReplDate(dest);
     if not DirectoryExists(dest) then
       begin
        suc:=ForceDirectories(dest);
        if suc then
            begin
           msg:=Utf8ToAnsi('Каталог создан ')+dest;
            WriteLog(msg,false);
//            WriteLog ('Dir created '+dest,false);
            end
         else
             begin
            msg:=Utf8ToAnsi('[Ошибка] Каталог неудалось создать ')+dest;
            WriteLog(msg,false);
//             WriteLog ('[Error] Not dir created '+dest,false);
             exit;
             end;
       end;
     dest:=dest+'\'+ExtractFileName(FileName);
     suc:=CopyF (FileName,dest);
     suc2:=DeleteFile(PChar(FileName));
     if suc and suc2 then
         begin
          msg:=Utf8ToAnsi('Файл перемещен ')+FileName+Utf8ToAnsi(' в ')+dest;
          WriteLog(msg,false);
//         WriteLog ('File '+FileName+' moved to '+dest,false)
         end
       else
         begin
          msg:=Utf8ToAnsi('[Ошибка] Не удалось переместить файл ')+FileName+Utf8ToAnsi(' в ')+dest;
          WriteLog(msg,false);
//         WriteLog ('[Error] Not moved file '+FileName+' to '+dest,false);
         end;
  end;
if SameText(act,'send') then   // отправка файла
  begin
    mailto:=GetValue(RulesTXT[num],'to');
    subj:=GetValue(RulesTXT[num],'subj');
    suc:=SendMail.Send(mailsrv,mailport,mailfrom,mailto,subj,'',filename);
     if suc then
         begin
          msg:=Utf8ToAnsi('Файл отправлен ')+FileName+Utf8ToAnsi(' на ')+mailto+Utf8ToAnsi(' тема: ')+subj;
          WriteLog(msg,false);
         end
       else
         begin
          msg:=Utf8ToAnsi('[Ошибка] Файл неудалось отправить ')+FileName+Utf8ToAnsi(' на ')+mailto+FileName+Utf8ToAnsi(' тема: ')+subj;
          WriteLog(msg,false);
         end;
  end;
if SameText(act,'sendmsg') then  // отравка уведомления, без отправки файла
  begin
    mailto:=GetValue(RulesTXT[num],'to');
    subj:=GetValue(RulesTXT[num],'subj');
    msg:=GetValue(RulesTXT[num],'text');
    msg:=StringReplace(msg,'%filename%',ExtractFileName(filename),[rfReplaceAll, rfIgnoreCase]);
    msg:=StringReplace(msg,'%file%',filename,[rfReplaceAll, rfIgnoreCase]);
    suc:=SendMail.Send(mailsrv,mailport,mailfrom,mailto,subj,msg,'');
     if suc then
         begin
          msg:=Utf8ToAnsi('Сообщение о файле отправлено ')+FileName+Utf8ToAnsi(' на ')+mailto+Utf8ToAnsi(' тема: ')+subj;
          WriteLog(msg,false);
         end
       else
         begin
          msg:=Utf8ToAnsi('[Ошибка] Сообщение о файле неудалось отправить ')+FileName+Utf8ToAnsi(' на ')+mailto+FileName+Utf8ToAnsi(' тема: ')+subj;
          WriteLog(msg,false);
         end;
  end;



end;
}
//-------------------------------------------------------------------------
{Поиск строки str в файле с именем Filename
true - строка есть
false - строки нет
если строка пустая то возварщается true
чтение идет по строкам
}
function TFileMon.FindStrInFile(str:string;FileName:string):boolean;
var
 F:TextFile;
 ln:string;
 i:integer;
begin
if str='' then
  begin
  Result:=true;
  exit;
  end;
Result:=false;
    try
    AssignFile(F, FileName);
    except
    exit;
    end;
    Reset(F);
    Readln(F, ln); // прочитали строку
    while ln<>'' do
    begin
    i:=Pos(str,ln); // Ищем есть ли в строке искомая подстрока
    if i>0 then // есть
      begin
        CloseFile(F);
        Result:=true;
        exit;
      end;
    Readln(F, ln); // прочитали строку
    end;
    CloseFile(F);

end;
//-------------------------------------------------------------------------
{Скопировать файл}
function TFileMon.CopyF(sour,dest:string):boolean;
var
  NewFile: TFileStream;
  OldFile: TFileStream;
  msg:string;
begin
Result:=false;
    try
    OldFile := TFileStream.Create(sour, fmOpenRead or fmShareDenyWrite);
    except
    msg:=Utf8ToAnsi('[Ошибка] Файл источник не удалось открыть ')+sour;
    WriteLog(msg,false);
    exit;
    end;
    try
      NewFile := TFileStream.Create(dest, fmCreate or fmShareDenyRead);
      try
        NewFile.CopyFrom(OldFile, OldFile.Size);
        Result:=true;
      finally
        FreeAndNil(NewFile);
      end;
    finally
      FreeAndNil(OldFile);
    end;
end;
//------------------------------------------------------------------------
{Замена всяких символов типа %date% в строке на текущую дату}
function TFileMon.ReplDate(S:string):string;
var
 dt:TDateTime;
 str,str2,strdate:string;
begin
dt:=Now;
str:=FindStrVar (S);
while str<>'' do
begin
str2:='%'+str+'%';
DateTimeToString(strdate,str,dt);
s:=StringReplace(s,str2,strdate,[rfReplaceAll, rfIgnoreCase]);
str:=FindStrVar (S);
end;
Result:=s;
end;
//------------------------------------------------------------------------
{Загрузить правила из файла}
procedure TFileMon.LoadRules(FileName:string);
begin
if Not FileExists(FileName) then exit;
RulesTXT.LoadFromFile(FileName);
end;

//==============================================================================
{ TFileMon }
//------------------------------------------------------
// Чтение настроек из Ini файла
{
function TFileMon.ReadSet:boolean;
var
 tini:TIniFile;
 ininame,s:string;
begin
Result:=false;
ininame:=ChangeFileExt(ExeName,'.ini');
if Not FileExists(ininame) then
  begin
  s:=Utf8ToAnsi('Не найден конфигурационный файл ')+ininame;
  WriteLog(s,false);
  exit;
  end;
tini:=TIniFile.Create(ininame);
config:=tini.ReadString('frouter','config','');
if config='' then
  begin
  WriteLog('Нет строки config',true);
  exit;
  end;
if Not FileExists(config) then
  begin
  WriteLog('Не найден файл с правилами',true);
  exit;
  end;
mailsrv:=tini.ReadString('mail','mailsrv','');
mailfrom:=tini.ReadString('mail','mailfrom','');
mailport:=tini.ReadInteger('mail','mailport',25);
Result:=true;
end;
}
//----------------------------------------------------
// Получение имени лог файла типа: log\дата.log
function TFileMon.GetLogName:String;
var
 str:string;
begin
// Проверка и создание каталога для логов
str:=ExtractFilePath(ExeName)+'\log';
if Not DirectoryExists(WinToDos(str)) then
  begin
   ForceDirectories(WinToDos(str));
  end;
DateTimeToString(str,'yymmdd',Now);
Result:=ExtractFilePath(ExeName)+'log\'+str+'-'+CurrentRule+'.log';// Имя файла
Result:=WinToDos(Result);
end;
//----------------------------------------------------
//
{  Перекодировка и вывод строки utf на экран

procedure TFileMon.WriteLnUtf(str:string; utf:boolean);
begin
writeln(WinToDos(Utf8ToAnsi(str)));
end;
}
//--------------------------------------------------------
{  Вывод строки utf на экран и запись в лог
utf=false - win кодировка
utf=true - Utf кодировка
}
procedure TFileMon.WriteLog (Msg:string;utf:boolean);
var
// F1:TextFile;
 str:string;
 ch:char;
 i,j:integer;
begin
if utf then msg:=Utf8ToAnsi(msg);

DateTimeToString(str,'dd.mm.yyyy hh:mm:ss ',Now);
if msg='-' then str:='--------------------------------------------------------------'
  else
    str:=str+msg;
if Not FileExists(LogName) then i:=FileCreate(LogName)
 else i:=FileOpen(LogName,fmOpenWrite);
//WriteLn('i='+IntToStr(i));
if i>0 then
 begin
 FileSeek(i,0,2);
 for j:=1 to Length(str) do
 begin
 ch:=str[j];
 FileWrite(i,ch,sizeof(ch));
 end;

 FileWrite(i,13,1);
  FileWrite(i,10,1);
// AssignFile (F1,LogName);
// WriteLn (F1,WinToDos(str));

// CloseFile(F1);
  FileClose(i);
 end;
//AssignFile(F1,LogName);
//DateTimeToString(str,'dd:mm:yyyy hh:mm ',Now);
//WriteLn(F1,str,msg);
//CloseFile(F1);
str:=WinToDos(str);
writeln(str);
end;
//-----------------------------------------------------------




  {
Function TFileMon.WinToDos(Const S: String) : String;
 { Конвертирует строку из кодировки Windows в DOS кодировку }
begin
 SetLength(Result,Length(S));
 if  Length(S) <> 0  then
   CharToOem(pChar(S),pChar(Result));
end;
//-----------------------------------------------------------------
Function TFileMon.DosToWin(Const S: String) : String;
{ Конвертирует строку из кодировки DOS в Windows кодировку }
begin
 SetLength(Result,Length(S));
 if  Length(S) <> 0  then
   OemToChar(pChar(S),pChar(Result));
end;
   }
//--------------------------------------------------------------
procedure TFileMon.DoRun;
var
  str,str2:string;
begin
  writeln('FileRouter ver ',ver);
  LogName:=GetLogName; // Имя лог файла
  //LogName:=WinToDos(LogName);
  //WriteLog(LogName,false);
  config:=ExtractFileDir(ParamStr(0))+DirectorySeparator+'frouter.ini';
  CurrentRule:='';
//  config:='frouter.ini';
//  config:=ChangeFileExt(ExeName,'.ini');
  //config:=ansitoutf8(config);
  config:=WinToDos(config);
  if not  (FileExists(config)) then
//  if not  (FileExists(str2)) then
     begin
       writeLog('[Ошибка] Не найден файл с правилами ',true);
       Terminate;
       exit;
     end;
  if ParamCount<1 then
    begin
      writeLog('Запуск без параметров',true);
      writeHelp;
      //writeln('Use: frouter.exe Rule_name');
      Terminate;
      exit;

    end;
  CurrentRule:=ParamStr(1);
  LogName:=GetLogName;
  if ParamCount>1 then
     begin
     if SameText(ParamStr(2),'DeleteAtom') then
        begin
        GlobalDeleteAtom(FoundAtom); // Если чего-то подвисло запуск с параметром DeleteAtom Удаляет признак повтора
        WriteLog('Удаление признака повтора ',true);
        Terminate;
        exit;
        end;
     end;

  if not LookForPreviousInstance then // такой проги не запущено
    begin
    LoadRules(config);

    writeLog('Начало обработки правила '+CurrentRule,true);
     RunRules(CurrentRule);

    GlobalDeleteAtom(FoundAtom);
    end;

  writeLog('-',false);
  Terminate;
end;

constructor TFileMon.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
  StopOnException:=True;
  RulesTxt:=TStringList.Create;
  SendMail:=TSendMailS.Create;
  SendMail.mailport:=25;
//  mailport:=25;
end;

destructor TFileMon.Destroy;
begin

  RulesTxt.Free;
  SendMail.Free;
  inherited Destroy;
end;

procedure TFileMon.WriteHelp;
begin
  { add your help code here }
  writeln('Usage: ',ExeName,' Rule_name [DeleteAtom]');
 writeln('[DeleteAtom] - clear atom repeat flag on this rule');
end;

var
  Application: TFileMon;
begin
  Application:=TFileMon.Create(nil);
  Application.Run;
  Application.Free;
end.

