{
Copyright 2011 Kapustin Andrey

This file is part of FileRouter.

FileRouter is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FileRouter is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FileRouter.  If not, see <http://www.gnu.org/licenses/>.

Код распространяется по лицензии GPL 3
Автор: Капустин Андрей, 2011 г.
}

unit sendmail;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,
  smtpsend,mimemess,mimepart,synachar,ssl_openssl, //synapse
  unitfunc
  ;

type
  TSendMailS=class
  public
   function Send (mailto,subj,Body,FileName:string;var MsgError:string):boolean; // Отправить почту

   mailfrom:string; // От имени кого отправляется почта
   mailsrv:string; // Имя почтового сервера
   mailport:integer;
   mailuser:string; // Пользователь
   mailpass:string; // Пароль
  private

  end;

implementation


//=========================================================
// Отправка почты Synapse
// subj - тема письма
// Body - текст письма
// FileName - имя прикладываемого файла (Если не пусто)
// MsgError - ошибка, если возникла
// Возвращает true если все хорошо
function TSendMailS.Send (mailto,subj,Body,FileName:string;var MsgError:string):boolean;
var
   Msg : TMimeMess; //собщение
   MIMEPart : TMimePart; //части сообщения (на будущее)
   FilePart:TMimePart;
   SmtpSnd:TSmtpSend;
   BodyList,MailToList:TStringList;
   str:string;
   i:integer;
   FStream:TFileStream;
begin
Result:=true;
Msg := TMimeMess.Create; //создаем новое сообщение
BodyList := TStringList.Create;
MailToList:=TStringList.Create;
  try
// Добавляем заголовки
   try
//    Msg.Header.CharsetCode := synachar.UTF_8;
    Msg.Header.Subject := Subj;//тема сообщения
    Msg.Header.From := mailfrom; //имя и адрес отправителя
    Msg.Header.ToList.Add(mailto); //адрес получателя
// создаем корневой элемент
    MIMEPart := Msg.AddPartMultipart('alternate', nil);
    BodyList.Text:=Body;
    Msg.AddPartText(BodyList, MIMEPart);
//    Msg.AddPartTextEx(BodyList, MIMEPart, UTF_8, false, ME_7BIT);
    //str:=utf8toansi(FileName);
    if (FileName<>'') and (FileExists(FileName)) then
          begin
          str:=DosToWin(FileName);
          FStream:=TFileStream.Create(FileName,fmOpenRead,fmShareDenyWrite);
          str:=DosToWin(ExtractFileName(FileName));
          Msg.AddPartBinary(FStream,str,MIMEPart);
          FStream.Free;
//          FilePart:=Msg.AddPartBinaryFromFile(str,MIMEPart);
//          FilePart.FileName:='test.txt';
//          MimePart.
          end;

//          Msg.AddPartBinaryFromFile('mbackup.ini',MIMEPart);

// Кодируем и отправляем
    Msg.EncodeMessage;

 // Отправка классом
    SmtpSnd:=TSmtpSend.Create;
    SmtpSnd.TargetHost:=mailsrv;
    SmtpSnd.TargetPort:=IntToStr(mailport);
    SmtpSnd.UserName:=mailuser;
    SmtpSnd.Password:=mailpass;
    SmtpSnd.AutoTLS:=true;
    if Not SmtpSnd.Login then
      begin
      Result:=false;
      MsgError:=format('Ошибка SMTP Login: %s',[SmtpSnd.EnhCodeString]);
      exit;
      end;
  {  if not smtpSnd.StartTLS then
     begin
      Result:=false;
      MsgError:=format(rsSmtpStartTLSErr,[SmtpSnd.EnhCodeString]);
      exit;
     end;
     }
    if not smtpSnd.MailFrom(mailfrom, Length(mailfrom)) then
     begin
      Result:=false;
      MsgError:=format('Ошибка SMTP MailFrom: %s',[SmtpSnd.EnhCodeString]);
      exit;
     end;
    // Отправка на множественные адреса
    MailToList.Delimiter:=',';
    MailToList.DelimitedText:=MailTo;
    for i:=0 to MailToList.Count-1 do
    begin
    if not smtpSnd.MailTo(MailToList[i]) then

    //if not smtpSnd.MailTo('Andrey.Kapustin@volga.bnk.ru') then
      begin
      Result:=false;
      MsgError:=format('Ошибка SMTP MailTo %s: %s',[MailToList[i],SmtpSnd.EnhCodeString]);
      exit;
      end;
    end;
    //--конец множественной отправки
    if not smtpSnd.MailData(Msg.Lines) then
     begin
      Result:=false;
      MsgError:=format('Ошибка SMTP MailData: %s',[SmtpSnd.EnhCodeString]);
      exit;
     end;
    if not smtpSnd.Logout() then
      begin
      Result:=false;
      MsgError:=format('Ошибка SMTP Logout: %s',[SmtpSnd.EnhCodeString]);
      exit;
     end;
// Конец отправки классом



//    Result:=smtpsend.SendToRaw(Settings.mailfrom,Settings.email,Settings.smtpserv+':'+IntToStr(Settings.smtpport), Msg.Lines,Settings.smtpuser,Settings.smtppass);
   except on E:Exception do
      begin
      MsgError:=format('Ошибка SMTP: %s',[E.Message]);
//      LogMessage(MsgError);
      Result:=false;
      end;
   end;
 finally
   Msg.Free;
   BodyList.Free;
   MailToList.Free;
 end;


end;



end.

